html, body {
  height: 100%;
  width: 100%;
  padding: 0;
  margin: 0;
  font-size: 10px;
  overflow-x: hidden !important;
  overflow-y: hidden !important;
}


/*
  Override BB. Some CSS tweaks for having a better confirm readability
*/
form[role="dialog"][data-type="confirm"] p {
  margin-top: 0 !important;
  border-bottom: 0.1rem solid #686868;
}

form[role="dialog"][data-type="confirm"] p small{
  line-height: 2rem;
}


/* Override Building Block [Header] styles */
section[role="region"] > header:first-child .icon.icon-clear {
  background-image: url(images/icons/clear.png);
  background-position: center calc(50% + 0.1rem);
  background-size: 3rem;
  width: 2rem;
  margin: 0;
  padding: 0 2rem;
  position: absolute;
  top: 0;
  right: 0;
}

section[role="region"] > header:first-child form {
  display: none;
}

/* TODO: Move this into the shared building block
 * if we use the icon in more places
 */
section[role="region"] > header:first-child .icon.icon-attachment {
  background-image: url(images/icons/attachments.png);
}

/* Override Building Block [Imput areas] styles */
form.bottom[role="search"] {
  z-index: 3;
}

#messages-recipient {
  padding-right: 3rem;
  font-size: 1.8rem;
}

/* Override Building Block [Edit mode] styles */
form[role="dialog"][data-type="edit"] header {
  transform: translateY(-110%);
}

form[role="dialog"][data-type="edit"] > menu {
  transform: translateY(110%);
}

/* Override Building Block [Lists] styles */
[data-type="list"] {
  padding: 0;
  text-align: left;
}

#main-wrapper.edit [data-type="list"] li a {
  pointer-events: none;
}

#threads-container[data-type="list"] .mms-icon {
  display: none;
  margin-left: 0.3rem;

  font-size: 1.5rem;
  color: #ff6622;
}

#threads-container[data-type="list"] [data-last-message-type="mms"] .mms-icon {
  display: inline;
}

#threads-container[data-type="list"] [data-last-message-type="mms"] .body-text {
  display: none;
}

[data-type="list"] header {
  margin: 0 1.5rem;
}

#sticky {
  position: absolute;

  /* The sticky element is positioned at the beginning of the list. */
  top: 5rem;

  /* The width is not 100% so the scrollbar is visible. */
  width: calc(100% - 1.5rem);

  /* The height needs to be kept in sync with the header height. */
  height: 3.1rem;

  /* The sticky element needs to be above the list. */
  z-index: 2;

  /* Those style will affect the bagroundImage: -moz-element. */
  background-repeat: no-repeat;
  background-position: 1.5rem 0;
}

.edit #threads-container[data-type="list"] {
  height: calc(100% - 12rem);
}

#threads-container[data-type="list"] header {
  background: #fff;
}

#threads-container[data-type="list"] ul {
  padding: 0 1.5rem;
  background-color: #fff;
}

#threads-container[data-type="list"] aside.empty {
  display: none;
}

/**
 * Bug 967878, 979018 -[Messages] Background doesn't
 * scroll with the threads causing expensive over-invalidation
 */
#threads-container > div {
  background-color: #fff;
}

[data-type="list"] li > label {
  right: 5rem;
  display: block;
  overflow: hidden;
  opacity: 0;
}

[data-type="list"] aside.icon-unread {
  margin: 0;
  width: 1.5rem;
}

[data-type="list"] .unread aside.icon-unread {
  background: url("../style/images/unread.png") no-repeat left center / 1rem;
}

[data-type="list"] .threadlist-item a * {
  pointer-events: none;
}

[data-type="list"] .draft .icon-draft {
  background: url("../style/images/draft.png") no-repeat left center / 1rem;
}

[data-type="list"] .is-draft .pack-end {
  opacity: 0.5;
}

[data-type="list"] .is-draft .name {
  font-style: italic;
  color: #5f5f5f;
}

[data-type="list"] p time {
  display: inline-block;
}

[data-type="list"] .unread p time {
  color: #1D8399;
}

/* Lists: edit mode */
.edit [data-type="list"] li > label {
  opacity: 1;
  pointer-events: auto;
  left: -1.4rem;
}

.edit [data-type="list"] li > .pack-checkbox input ~ span:after {
  opacity: 1;
  transform: translateX(4.5rem);
  left: -2.2rem;
}

.edit [data-type="list"] li > a > aside.icon-unread {
  opacity: 0;
}

.edit [data-type="list"] li > a > p {
  transform: translateX(3.5rem);
  margin-right: 3.5rem;
}

.edit #threads-container[data-type="list"] aside.pack-end {
  margin: 0 0 0 -3rem;
}

.edit #threads-container[data-type="list"] aside.pack-end span {
  transform: translateX(7.5rem);
}

/* Panel handling */
#main-wrapper {
  position: absolute;
  overflow: hidden;
  width: 100%;
  height: 100%;
  left: 0;
  top: 0;
  background: #fff;
}

.panel:first-child {
  left: 0;
}

.panel {
  position: absolute;
  left: 100%;
  width: 100%;
  height: 100%;

  transition: transform 0.4s ease;
}

#main-wrapper[data-position='left'] .panel {
  transform: translateX(-100%);
}

#main-wrapper[data-position='right'] .panel {
  transform: translateX(0%);
}

#threads-container, #thread-messages {
  z-index: 10;
  background: white;
}

#messages-contact-pick-button {
  display: none;
}

#messages-new-message-notice {
  display: flex;
  flex-direction: row;

  padding: 1rem 1.5rem 1rem 2rem;
  overflow: hidden;

  white-space: nowrap;
  line-height: 2rem;
  font-size: 1.8rem;
  text-align: left;
}

#messages-new-message-notice a {
  margin: 0;
}

#messages-new-message-notice .contact {
  overflow: hidden;

  text-overflow: ellipsis;
  white-space: nowrap;
}

#messages-new-message-notice > div:first-child {
  flex: auto;

  overflow: hidden;
}

#messages-new-message-notice > div:nth-child(2) {
  flex: none;

  padding: 0.2rem 0 0.2rem 1.5rem;
}

/*
  Styles for Edit mode in Thread List
*/

.edit form[role="dialog"][data-type="edit"] > menu {
  transform: translateY(0);
}

.edit form[role="dialog"][data-type="edit"] header {
  transform: translateY(0);
}

.edit #threads-container .checkbox-container {
  pointer-events:auto;
  opacity: 1;
  transform: translateX(0);
}

.edit .undo-candidate {
  display: none;
}

.edit .message-block {
  border-top: .1rem solid #DBDBDB;
  margin-bottom: 0;
}

/*
  Styles for new message
*/

section[role="region"].new > header:first-child h1 {
  pointer-events: none;
}

section[role="region"].new > header:first-child form {
  display: block;
}

.new #messages-contact-pick-button {
  display: block;

  width: 5rem;
  height: 4rem;
}

#messages-contact-pick-button .icon-user {
  position: absolute;
  top: 0.6rem;
  right: 1rem;

  display: block;
  width: 2.8rem;
  height: 2.8rem;
  border-radius: 50%;

  color: #575757;
  background-color: #FFF;
}

#messages-contact-pick-button .icon-user:after {
  content: "+";
  position: absolute;

  display: block;
  width: 2.8rem;
  height: 2.8rem;

  line-height: 2.8rem;
  font-size: 2.1rem;
  font-weight: 500;
  text-align: center;
}

#messages-contact-pick-button .icon-user:active {
  color: #FFF;
  background-color: #29bbb5;
}
/*
  Messages Style as 'bubbles'
*/

.carrier-wrapper,
.carrier-wrapper * {
  display: none;
}

.carrier-wrapper {
  box-sizing: border-box;
  height: 2.2rem;
  padding-left: 1.5rem;

  font-size: 1.4rem;
  line-height: 2.2rem;
  text-align: left;
  text-overflow: ellipsis;
  overflow: hidden;
  white-space: nowrap;
  border-bottom: 0.1rem solid #ebebeb;

  background: rgba(255, 255, 255, 0.95);
  color: #575757;
}

.carrier-wrapper.has-phone-type .phone-type,
.carrier-wrapper.has-phone-details .phone-details,
.carrier-wrapper.has-phone-type.has-phone-details .phone-type-separator {
  display: inline;
}

.has-carrier .carrier-wrapper {
  display: block;
}

#messages-container {
  background: #fff;
}

#messages-container .messages-date-group-header {
  position: sticky;
  top: 0;
  z-index: 1;

  height: 2.2rem;
  margin: 0 0 0.6rem;

  font-size: 1.4rem;
  line-height: 2.2rem;
  text-transform: uppercase;

  background: rgba(255, 255, 255, 0.85);
  color: #575757;
}

/* If has carrier change top position */
.has-carrier #messages-container .messages-date-group-header {
  top: 2.2rem;
}

.has-carrier #messages-container .messages-date-group-header:first-child {
  margin-top: 2.2rem;
}

/* TODO: check whether we need this rule */
#messages-container .messages-date-group-header.hidden {
  display: none;
}

.new .article-list {
  z-index: 5;

  padding: 0;

  background: none repeat scroll 0 0 #fff;
  text-align: left;
}

.article-list[data-type="list"] .message {
  position: relative;
  z-index: 0; /* bug 970422 */

  display: block;
  overflow: hidden;
  width: 100%;
  height: auto;
  margin-bottom: 1rem;
  border-bottom: none;

  transition: none;
}

.article-list[data-type="list"] .message.hidden {
  display: none;
}

.article-list[data-type="list"] .message .bubble p {
  padding: 0;

  line-height: 2rem;
  font-size: 1.8rem;
  text-align: left;
  white-space: pre-wrap;
  color: #333;
}

.article-list[data-type="list"] .message.no-attachment .bubble p {
  height: 2.3rem;
}

/* remove margin for notice-button class of button */
.notice-button {
  margin: 0;
}

#messages-container[data-type="list"] .message.mms .bubble img {
  height: auto;
  width: auto;
}

/*
  Styles for Edit mode in Messages Container
*/

.edit #composer-messages-container {
  margin-bottom: 4.0rem;
}

.edit .article-list[data-type="list"] .message {
  border-color: #e7e7e7;
}

.edit [data-type="list"] .message .bubble {
  pointer-events: none;
}

/* In edit mode we hide progress bar for all message types and hide background
   for the incoming messages as checkbox should appear at the same place */
.edit .message .bubble .message-status progress {
  display: none;
}

.edit .message.incoming .bubble .message-status {
  background: none;
}

.edit-button {
  background: -moz-linear-gradient(top, #b50404 0%, #850a0a 100%);
  height: 100%;
  width: 100%;
  box-sizing: border-box;
  font-weight: 600;
  font-size: 1.6rem;
  color: white;
  opacity: 0.99; /* hackaround for painting bug (bug 821221) */
}

.disabled {
  opacity: 0.3;
  pointer-events: none;
}

.edit #messages-compose-form {
  display: none;
}

.edit #composer-messages-container {
  margin-bottom: 7rem;
}

/* Add a margin at the end of the last thread or message node to avoid overlay
 * with the edit mode menu */
.edit .edit-container {
  padding-bottom: 7rem;
}

/*
  Loading screen while deleting
*/

#loading.show-loading {
  display: block;
}

#loading {
  display: none;
}

.loading-header {
  text-align: left;
}

#loading [role="status"] {
  text-align: center;
  height: 4rem;
}

#loading p {
  border-bottom: none;
}

/*
  No result container
*/

#threads-no-messages {
  background-image: url('images/SMS_200x200_bubble.png');
  background-repeat: no-repeat;
  background-position: center;
  background-size: 20rem;
  overflow-y: auto;
  overflow-x: hidden;
  height: calc(100% - 5rem);
  width: 100%;
}

#no-result-message {
  position: relative;
  top: 50%;

  width: 27rem;
  padding: 2rem 0.5rem;
  margin: -8rem auto;
  border-top: .1rem solid rgba(96,96,96,.5);

  line-height: 3rem;
  text-align: left;
  font-weight: 300;
  font-size: 2.2rem;
  color: #606060;
}

/*
  Styles related to the layout of the composer
*/

section[role="region"].new .subheader {
  height: 0;
}

#messages-to-field {
  position: relative;
  /* To be above .article-list's with z-index = 5 */
  z-index: 6;

  display: none;
  min-height: 5.5rem;

  text-align: left;
  color: black;
  font-size: 1.465rem;
  background-color: #f2f2f2;
  transition: transform 0.2s ease-in-out 0s;
  transform: translateY(calc(-100% + 5.5rem));
}

section[role="region"].new #messages-to-field {
  display: flex;
  align-items: flex-end;
}


section[role="region"].new #messages-to-field.multiline {
  transform: translateY(0);
}

#to-label {
  flex-shrink: 0;

  height: 4rem;
  padding-left: 1.5rem;
  padding-right: 0.7rem;

  line-height: 4rem;
  font-weight: 200;
  font-size: 1.465rem;
  color: #000;
}

#messages-recipients-list-container {
  min-height: 4rem;
  box-sizing: border-box;

  flex-grow: 1;
}

#messages-recipients-list {
  box-sizing: border-box;
  min-height: 4rem;
  padding: 0 0.6rem 0.6rem 0;
}

/*
Used by Recipients.View to display multi or single line.
Do not remove.
*/
#messages-recipients-list.singleline {
  overflow-y: hidden;
}

#messages-recipients-list.multiline {
  /* max-height = viewport - header - minimum composer - list margin */
  max-height: calc(100vh - 5rem - 3.7rem - 0.6rem);
  margin-bottom: 0.6rem;

  overflow-y: scroll;
}

.recipient[contenteditable] {
  overflow: hidden;
  /* Editable recipients have no `padding-left` so that they align with
  * "assimilated" recipients (see `ThreadUI.assimilateRecipients`), but they
  * maintain twice the `padding-right` so they wrap as if "assimilated". For
  * discussion of this behavior, see "Bug 905260 - [messages] padding issues
  * in the recipient panel". */
  margin: 0.6rem 0.6rem 0 0;
  max-width: calc(100% - 2rem);
  padding-right: 1.6rem;

  display: block;
  float: left;
}

/* Disable padding and margin on empty contenteditable recipients when they do
 * not have focus. This allows the Recipients List to intelligently collapse
 * when the final row contains no "assimilated" (i.e. non-contenteditable)
 * recipients. */
.recipient[contenteditable=true]:empty {
  margin: 0;
  padding: 0;

  word-wrap: unset;
  background: none;
}

.recipient[contenteditable=true]:focus,
.recipient[contenteditable=true]:empty:focus {
  margin: 0.6rem 0.5rem 0 0;
  padding: 0 0.3rem 0 0;

  height: 2.8rem;
  line-height: 2.8rem;
  border-radius: 0;

  word-wrap: unset;
  background: none;
}

#messages-recipient-suggestions {
  position: absolute;
  /* 10.5rem (5 rem from app header + 5.5rem from "To" panel heights) */
  top: 10.5rem;

  overflow-y: auto;

  max-height: calc(100% - 10.5rem);
  width: 100%;
}

#messages-recipient-suggestions li:first-child {
  margin-top: 0;
}

.article-list[data-type="list"] ul.contact-list {
  overflow-x: hidden;
  overflow-y: auto;

  width: calc(100% - 3.1rem);
  padding: 0 1.5rem;

  background: #fff;
}

body[role="application"] form[role="dialog"][data-type="action"] > section:first-child{
  height: auto;
  border-bottom: 0.1rem solid #616262;
  padding-bottom: 1rem;
  padding-left: 2.5rem;
}

/* building blocks overload
 * TODO load building-blocks CSS before sms.css so that we don't need !important
 * Bug XXX
 */
form[role="dialog"][data-type="action"].contact-prompt > header {
  height: auto;
  min-height: 5rem;
  font-weight: 100;
}

.contact-header {
  /* bottom padding is .9rem because we need .1rem more for the
   * nice shadow line at the header bottom, defined as a :after element */
  padding: 0.8rem 0 0.9rem;
}

.contact-header .name {
  line-height: 2.5rem;
  padding: 0.5rem 0 0.8rem;
  margin: 0;
  overflow: hidden;
  text-overflow: ellipsis;

  font-size: 2.3rem;
}

.contact-header .details {
  line-height: 1.5rem;
  padding: 0 0 0.7rem;
  margin: 0;
  overflow: hidden;

  font-size: 1.5rem;
}

.contact-header span[data-type=img] {
  display: block;
  width: 6rem;
  height: 6rem;
  background-size: cover;
  background-position: center;
}

.contact-header aside.pack-end {
  float: right;
  margin-right: -1.5rem; /* compensate the header's 3rem padding */
}

body[role="application"] form[role="dialog"][data-type="action"] > header:first-child{
  text-align: left;
}

section[role="region"].new .article-list[data-type="list"]  li:first-child {
  margin-top: 4.6rem;
}

section[role="region"].new .article-list[data-type="list"]  li {
  pointer-events: auto;
}

.suggestion * {
  pointer-events: none;
}

.subheader {
  position: absolute;
  z-index: 6; /* should be between 4 and 9 (inclusive). 3 is the z-index for
                 the input form, 10 is the z-index for the header */
  left: 0;
  right: 0;
  top: 5rem;
}

.subheader menu {
  position: relative;
  flex-shrink: 0;

  width: 5rem;
  height: 4rem;
}

/* Elements related to information view */
section[role="region"][class$='information'] #messages-options-icon,
section[role="region"][class$='information'] #messages-attach-button,
section[role="region"][class$='information'] #messages-subheader,
section[role="region"][class$='information'] #messages-container,
section[role="region"][class$='information'] #messages-compose-form {
  display: none;
}

/* Override icon style with close one */
section[role="region"].report-information > header .icon-back {
  background-image: url(/shared/style/headers/images/icons/close.png);
}

#messages-back-button:hover {
  background-color: transparent;
}

/* Activity mode specific style */
#messages-close-button {
  display: none;
}

.request-activity-mode #messages-close-button,
.request-activity-mode .report-information #messages-back-button,
.request-activity-mode .participants-information #messages-back-button {
  display: block;
}

.request-activity-mode #messages-back-button,
.request-activity-mode .report-information #messages-close-button,
.request-activity-mode .participants-information #messages-close-button {
  display: none;
}
